// Copyright 2006 FoxyTunes
// All Rights Reserved

/*
            var request = new XMLHttpRequest();            
            var url = URL;
            request.open('get', url, true);
            request.onreadystatechange = function() {
                if (request.readyState == 4) {
                    if (request.status == 200) {
                        var xml = request.responseXML;
                        var feed = new FTFeed(url);
                        feed.parse(xml);
                        dump(feed);
                    } else {
                        dump('error');
                    }
                }
           }
           request.send(null);
*/

function FTFeedItem(title, location, date, text, enclosure) {
    title = title.replace(/[\n\r]/g, '');
    this.title = title;
    this.location = foxytunesSanitizeURL(location);
    this.date = date;
    this.text = text;
    this.enclosure = foxytunesSanitizeURL(enclosure);
}

FTFeedItem.prototype.toString = function() {
    var str = '';
    str += 'title: ' + this.title + '\n';
    str += 'location: ' + this.location + '\n';
    str += 'date: ' + this.date + '\n';
    str += 'text: ' + this.text + '\n';
    str += 'enclosure: ' + this.enclosure + '\n';
    return str;
}

function FTFeed(feedURL) {
    this.feedURL = feedURL;
    this.title = null;
    this.location = null;
    this.description = null;
    this.items = [];
    this.isPodcast = false;
}

FTFeed.prototype.toString = function() {
    var str = '';
    str += 'title: ' + this.title + '\n';
    str += 'feedURL: ' + this.feedURL + '\n';
    str += 'location: ' + this.location + '\n';
    str += 'description: ' + this.description + '\n';
    for (var i=0; i < this.items.length; i++) {
        str += '------------\n';
        str += this.items[i].toString();
    }
    return str;
}

FTFeed.prototype.fixup = function() {
    this.location = foxytunesSanitizeURL(this.location);
},

FTFeed.prototype.removeHTML = function(str) {
    str = str.replace(/<[^>]+>/g, ' ');
    str = str.replace(/ +/g, ' ');
    str = str.replace(/^ */, '');
    str = str.replace(/ *^/, '');
    return str;
}

FTFeed.prototype.parse = function(xml) {
    var bParsed = false;
    if (xml.documentElement.localName.toLowerCase() == 'feed') {
        this.fromAtom(xml);
        bParsed = true;
    }

    if (xml.documentElement.localName.toLowerCase() == 'rss') {
        this.fromRSS(xml);
        bParsed = true;
    }

    if (bParsed) {
        this.fixup();
    }

    return bParsed;
},

FTFeed.prototype.fromRSS = function(xml) {
    this.title    = xml.evaluate("/rss/channel/title/text()", 
                                    xml, null, XPathResult.STRING_TYPE, null).stringValue;
    this.location = xml.evaluate("/rss/channel/link/text()", 
                                    xml, null, XPathResult.STRING_TYPE, null).stringValue;
    this.description = xml.evaluate("/rss/channel/description/text()", 
                                    xml, null, XPathResult.STRING_TYPE, null).stringValue;
    var items = xml.evaluate("/rss/channel/item", xml, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
    var uris = [];
    for (var i = 0; i < items.snapshotLength; i++) {
        var item = items.snapshotItem(i);
        var title = xml.evaluate("title/text()", item, null, XPathResult.STRING_TYPE, null).stringValue;
        var link  = xml.evaluate("link/text()", item, null, XPathResult.STRING_TYPE, null).stringValue;
        var description  = xml.evaluate("description/text()", item, null, XPathResult.STRING_TYPE, null).stringValue;
        var pubDate  = xml.evaluate("pubDate/text()", item, null, XPathResult.STRING_TYPE, null).stringValue;
        var enclosureURL  = xml.evaluate("enclosure/@url", item, null, XPathResult.STRING_TYPE, null).stringValue;
        if (enclosureURL) {
            this.isPodcast = true;
        }
        var feedItem = new FTFeedItem(title, link, pubDate, description, enclosureURL);
        this.items.push(feedItem);
    }
}

FTFeed.prototype.fromAtom = function(xml) {
    var NSResolver = function(prefix) { 
            if (prefix == 'xhtml') {
                return 'http://www.w3.org/1999/xhtml';
            } else {
                return xml.documentElement.namespaceURI; 
            }
    }
    this.title    = xml.evaluate("/xmlns:feed/xmlns:title/text()", 
                                    xml, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
    this.location = xml.evaluate("/xmlns:feed/xmlns:link/@href", 
                                    xml, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
    this.description = xml.evaluate("/xmlns:feed/xmlns:subtitle/text()", 
                                    xml, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
    if (!this.description) {
        this.description = xml.evaluate("/xmlns:feed/xmlns:tagline/text()", 
                                    xml, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
    }
    var items = xml.evaluate("/xmlns:feed/xmlns:entry", xml, NSResolver, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
    var uris = [];
    for (var iItem = 0; iItem < items.snapshotLength; iItem++) {
        var item = items.snapshotItem(iItem);
        var title = xml.evaluate("xmlns:title/text()", item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        var link  = xml.evaluate('xmlns:link[@rel="alternate" and @type="text/html"]/@href', 
                        item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        var contentType = xml.evaluate("xmlns:content/@type", item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        var content  = xml.evaluate("string(xmlns:content)", 
                                item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;

        var date  = xml.evaluate("xmlns:updated/text()", item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        if (!date) {
            date = xml.evaluate("xmlns:modified/text()", item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        }
        var enclosureURL  = xml.evaluate('xmlns:link[@rel="enclosure" and @type="audio/mpeg"]/@href', 
                        item, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
        if (!enclosureURL && 
            ((contentType == 'application/xhtml+xml') || (contentType == 'xhtml'))) {
            var links = xml.evaluate("xmlns:content//xhtml:a", 
                                item, NSResolver, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
            for (var iLink = 0; iLink < links.snapshotLength; iLink++) {
                var link = links.snapshotItem(iLink);
                var url = xml.evaluate("@href", link, NSResolver, XPathResult.STRING_TYPE, null).stringValue;
                if (url.match(/\.mp3$/)) {
                    enclosureURL = url;
                    break;
                }
            }
        }

        if (enclosureURL) {
            this.isPodcast = true;
        }
        var feedItem = new FTFeedItem(title, link, date, content, enclosureURL);
        this.items.push(feedItem);
    }
}
