// Copyright 2006 FoxyTunes
// All Rights Reserved

function FTPlayerConfig() {
    this._prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
}

FTPlayerConfig.prototype = {
    getReadableName : function(playerName) {
        var branch = this._prefs.getBranch("foxytunes.player_readable_name.");
        var name = '';
        try {
            name = branch.getCharPref(playerName);           
        } catch(e) {}
        return name;
    },

    needsConfig : function(playerName) {
        var branch = this._prefs.getBranch("foxytunes.player_needs_config.");
        var needs = false;
        try {
            needs = branch.getBoolPref(playerName);
        } catch(e) {}
        return needs;             
    },

    wasConfigured : function(playerName) {
      var branch = this._prefs.getBranch("foxytunes.player_was_configured.");
      var wasConfigured = false;
      try {
        wasConfigured = branch.getBoolPref(playerName);
      } catch(e) {}
      return wasConfigured;
    },

    setWasConfigured : function(playerName) {
      var branch = this._prefs.getBranch("foxytunes.player_was_configured.");
      branch.setBoolPref(playerName, true);
    },

    getConfigURL : function(playerName) {
      var branch = this._prefs.getBranch("foxytunes.player_config_url.");
      var url = '';
      try {
          url = branch.getCharPref(playerName);
      } catch(e) {}
      return url;
    },

    getSupportedExtensions : function(playerName) {
      var branch = this._prefs.getBranch("foxytunes.supported_extensions.");
      var ext = '';
      try {
          ext = branch.getCharPref(playerName);
      } catch(e) {}
      return ext;
    },

    getSupportsSubscribeToPodcast : function(playerName) {
      var branch = this._prefs.getBranch("foxytunes.supports_podcasts.");
      var supports = false;
      try {
          supports = branch.getBoolPref(playerName);
      } catch(e) {}
      return supports;
    },

    getSupportsDynamicMp3Stream : function(playerName) {
      var supportedExtensionsRegExp = gFTPlayerConfig.getSupportedExtensions(playerName);
      if (supportedExtensionsRegExp && supportedExtensionsRegExp == "PLAY_URI_NOT_SUPPORTED") {	
        return false;
	  }
      var branch = this._prefs.getBranch("foxytunes.supports_dynamic_mp3_stream.");
      var supports = true;
      try {
          supports = branch.getBoolPref(playerName);
      } catch(e) {}
      return supports;
    },

    openConfigDialog : function(playerName) {
      var url = this.getConfigURL(playerName);
      if (!url) return;

      window.openDialog(url, "_blank", "centerscreen,chrome,modal,resizable");
    },

    getPlayerConfigVariable : function(playerName, varName) {
         var branch = this._prefs.getBranch("foxytunes.player_config." + playerName + ".");
         var val = '';
         try {
            val = branch.getCharPref(varName);
         } catch(e) {}
         return val;
    },

    setPlayerConfigVariable : function(playerName, varName, varValue) {
         var branch = this._prefs.getBranch("foxytunes.player_config." + playerName + ".");
         branch.setCharPref(varName, varValue);
    },

    getPlayerConfigCommandLine : function(playerName) {
         var branch = this._prefs.getBranch("foxytunes.player_config." + playerName + ".");
         var children = branch.getChildList("", {});
         var commandLine = '';
         for (var i=0; i < children.length; i++) {
                var variable = children[i];
                var val = this.getPlayerConfigVariable(playerName, variable);              
                if (val) {
                    commandLine += ' -' + variable + ' ' + val;
                }
         }
         return commandLine;
    }
}


var gFTPlayerConfig = new FTPlayerConfig();

