// Copyright 2006 FoxyTunes
// All Rights Reserved

function FoxyTunesSearchEngineService() {
    var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                 .getService(Components.interfaces.nsIRDFService);
    this._inner = RDF.GetDataSourceBlocking("chrome://foxytunes/content/search/foxytunesSearchEngines.rdf");
}

FoxyTunesSearchEngineService.prototype = {

  _inner : null,

  /////////////////////////////////////////////////////////////////////////////
  // nsIRDFDataSource

  get URI() {
    return "rdf:foxyTunesSearchEngines";
  },

  AddObserver: function(observer) {
    return this._inner.AddObserver(observer);
  },

  ArcLabelsIn: function(node) {
    return this._inner.ArcLabelsIn(node);
  },
  
  ArcLabelsOut: function(source) {
    return this._inner.ArcLabelsOut(source);
  },

  Assert: function(source, property, target, truthValue) {
    this._inner.Assert(source, property, target, truthValue);
  },

  beginUpdateBatch: function() {
    return this._inner.beginUpdateBatch();
  },

  Change: function(source, property, oldTarget, newTarget) {
    this._inner.Change(source, property, oldTarget, newTarget);
  },

  DoCommand: function(sources, command, arguments) {
    this._inner.DoCommand(sources, command, arguments);
  },

  endUpdateBatch: function() {
    return this._inner.endUpdateBatch();
  },

  GetAllCmds: function(source) {
    return this._inner.GetAllCmds(source);
  },

  GetAllResources: function() {
    return this._inner.GetAllResources();
  },

  GetSource: function(property, target, truthValue) {
    return this._inner.GetSource(property, target, truthValue);
  },
  
  GetSources: function(property, target, truthValue) {
    return this._inner.GetSources(property, target, truthValue);
  },

  GetTarget: function(source, property, truthValue) {
    return this._inner.GetTarget(source, property, truthValue);
  },
  
  GetTargets: function(source, property, truthValue) {
    return this._inner.GetTargets(source, property, truthValue);
  },

  hasArcIn: function(node, arc) {
    return this._inner.hasArcIn(node, arc);
  },
  
  hasArcOut: function(source, arc) {
    return this._inner.hasArcOut(source, arc);
  },
 
  HasAssertion: function(source, property, target, truthValue) {
    return this._inner.HasAssertion(source, property, target, truthValue);
  },

  IsCommandEnabled: function(sources, command, arguments) {
    return this._inner.IsCommandEnabled(sources, command, arguments);
  },

  Move: function(oldSource, newSource, property, target) {
    this._inner.Move(oldSource, newSource, property, target);
  },

  RemoveObserver: function(observer) {
    this._inner.RemoveObserver(observer);
  },

  Unassert: function(source, property, target) {
    this._inner.Unassert(source, property, target);
  }, 

  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsIRDFDataSource) &&
        !iid.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};
