// Copyright 2006 FoxyTunes
// All Rights Reserved

function foxytunesIsInMineField() {
        return (navigator.userAgent.search(/MineField/gi) != -1);
}

function foxytunesIsInIceweasel() {
        return (navigator.userAgent.search(/Iceweasel/gi) != -1);
}

function foxytunesIsInFirefox() {
	return ((navigator.userAgent.search(/Firefox/gi) != -1) || foxytunesIsInIceweasel() || foxytunesIsInMineField());
}

function foxytunesIsInThunderbird() {
	return (navigator.userAgent.search(/Thunderbird/gi) != -1);
}

function foxytunesIsInMozilla() {
	return (!foxytunesIsInFirefox() && !foxytunesIsInThunderbird() && !foxytunesIsInEmusic());
}

function foxytunesIsInEmusic() {
   try {
       var app = Components.classes["@mozilla.org/xre/app-info;1"]
                   .getService(Components.interfaces.nsIXULAppInfo)
                   .QueryInterface(Components.interfaces.nsIXULRuntime);
       return (app.name.search(/emusic/gi) != -1);
   } catch (e) {};
   return false;
} 

function getFoxyTunesPlanetBaseURL() {
    return "http://www.foxytunes.com";
}

function foxytunesAdjustStringForCorrectHost(str) {
	if (foxytunesIsInThunderbird()) {
		str = str.replace('Firefox', 'Thunderbird');
	}

	if (foxytunesIsInMozilla()) {
		str = str.replace('Firefox', 'Mozilla');
	}
	return str;
}

function foxytunesLaunchExternalURLFromThunderbird(url) {
        var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();         
        messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
        messenger.launchExternalURL(url);         
}

function foxytunesLaunchExternalURL(url) {
    // first construct an nsIURI object using the ioservice
    var ioservice = Components.classes["@mozilla.org/network/io-service;1"]
                          .getService(Components.interfaces.nsIIOService);

    var uriToOpen = ioservice.newURI(url, null, null);

    var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                      .getService(Components.interfaces.nsIExternalProtocolService);

    // now, open it!
    extps.loadURI(uriToOpen, null);
}

function foxytunesShouldUseMinibrowser() {
        return (foxytunesIsInMinimode() && !foxytunesIsInEmusic());
}

function foxytunesCalculateMinibrowserPosition() {
    var dockToWin = foxytunesWindowIsMinimode(window.opener) ? window.opener : window;
    var bDockBelow = dockToWin.screenY < window.screen.height/2;
    var targetTop = dockToWin.screenY;
    var targetBottom = targetTop + dockToWin.outerHeight;
    var targetRight = dockToWin.screenX + dockToWin.outerWidth;

    var prefs = new FTJSLib.Prefs();
    var miniBrowserWidth = prefs.getInt('foxytunes.minibrowser.width');
    if (miniBrowserWidth == -Components.results.NS_ERROR_FAILURE) {
        miniBrowserWidth = 800;
    }
    var miniBrowserHeight = prefs.getInt('foxytunes.minibrowser.height');
    if (miniBrowserHeight == -Components.results.NS_ERROR_FAILURE) {
        miniBrowserWidth = 400;
    }

    var wantedX = targetRight - miniBrowserWidth;
    var wantedY = bDockBelow ? targetBottom : targetTop - miniBrowserHeight;
    return [wantedX, wantedY];
}

function foxytunesGetMinibrowserURL() {
    var ver = foxytunesGetAppVersion();
    if (ver && ver.match(/^2/)) {
       return 'chrome://foxytunes/content/minibrowser/browser.2.0.xul'; 
    }
    if (ver && ver.match(/^3/)) {
       return 'chrome://foxytunes/content/minibrowser/browser.3.0.xul'; 
    }

    return 'chrome://foxytunes/content/minibrowser/browser.xul';
}


function foxytunesSanitizer() {
}

foxytunesSanitizer.prototype = {
    replaceTriangularBrackets : function(str) {
        return str.replace(/</g, '(').replace(/>/g, ')');
    },

    replaceEncodedTriangularBrackets : function(str) {
        return str.replace(/%3[Cc]/g, '(').replace(/%3[Ee]/g, ')');
    },
    
    sanitizeURL : function(url) {
        var sanitizedURL = this.replaceTriangularBrackets(url);
        sanitizedURL = this.replaceEncodedTriangularBrackets(sanitizedURL);
        return sanitizedURL;
    } 
}

var gFoxyTunesSanitizer = new foxytunesSanitizer();

function foxytunesOpenBrowserWindow(urls) {
    // urls should be "|" delimeted
    // do not call directly, should be called fron *GoTo* functions

    var browserURL = foxytunesShouldUseMinibrowser() ?  foxytunesGetMinibrowserURL() :  
                                                        'chrome://browser/content/browser.xul';
    var features = "chrome,all,dialog=no";
    if (foxytunesShouldUseMinibrowser()) {
        // this is needed to clear the screenX/screenY values in localstore
        // which cause incorrect positioning of the minibrowser
        foxytunesFixLocalStore(); 
        var pos = foxytunesCalculateMinibrowserPosition();
        features += ', left=' + pos[0] + ', top=' + pos[1];          
    }

    openDialog(browserURL, "_blank", features, urls);
}

function foxytunesGetPlanetUrl(trackData, target, sID) {
        var url = getFoxyTunesPlanetBaseURL();
        var urlPrefix = "client=foxytunes-" + foxytunesGetAppName() + "&s=" + sID;

        if (target == 'genre') {
            url += '/explore?' + urlPrefix;
            return url;
        }
        if (trackData && trackData.title) {
            if (trackData.artist) {
                    var artist = trackData.artist ? encodeURIComponent(trackData.artist) : "-";
                    var album  = trackData.album  ? encodeURIComponent(trackData.album)  : "-";
                    var title  = trackData.title  ? encodeURIComponent(trackData.title)  : "-";
        
                    url += "/goto/" + target + "/" + artist + "/" + album + "/" + title + "?" + urlPrefix;
             } else {
   		            url += "/search?q=" + encodeURIComponent(trackData.title) + "&redirect=0&" + urlPrefix;
             }
        } else {
            url += '/goto/-/?' + urlPrefix;
        }

        return url;
}

function foxytunesGotoPlanet(target, sID, trackData) {
    if ((typeof trackData == 'undefined') && (target != 'genre')) {
        trackData = foxytunesGetCurrentTrackData();
    }
    var url = foxytunesGetPlanetUrl(trackData, target, sID);
    if (!url) return;
    foxytunesGoToURL(url);
}

function foxytunesRaiseBrowserWindow(url, bOpenNewTab) { 
    if (typeof bOpenNewTab == 'undefined') {
        bOpenNewTab = false;
    }
    var win = foxytunesGetBrowserWindow();
    if (win) {
        var pos = foxytunesCalculateMinibrowserPosition();
        win.moveTo(pos[0], pos[1]);
        win.restore();
        win.focus();
	if (url && bOpenNewTab) {
		foxytunesGoToURL(url);
	}
    } else {
        if (!url) {
            url = foxytunesGetInfoCenterUrl(null);
        }
        foxytunesOpenBrowserWindow(url);
    }
}

function foxytunesGetBrowserWindow() {
    if (window.getBrowser) {
         return window;
    } 

    var browserWindowType = foxytunesShouldUseMinibrowser() ? "foxytunes:minibrowser" :  "navigator:browser";

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
        
    var win = wm.getMostRecentWindow(browserWindowType, true);
    if (win && win.toolbar.visible) {
        return win;
    }

    // else
    var windows = wm.getEnumerator(browserWindowType, true);
    while (windows.hasMoreElements()) {
       win = windows.getNext();
       if (win.toolbar.visible) {
            return win;
       } 
    }

    return null;
}

function foxytunesGetEmusicWindow() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
        
    var win = wm.getMostRecentWindow("emusic:window", true); 
    if (win) return win;
    return null;
}

function foxytunesShouldOpenWindowsInTabs() {
	// always open in tab
	return true;

    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefBranch);
    try {
            return prefs.getBoolPref("foxytunes.open_window_in_tab");
    } catch(e) {
            return true;
    }
}

function foxytunesEmusicGoToUrl(url) {
    var browser = document.getElementById('content');
    if (browser) {
         dlm_web.goThere(url);
    } else {
        var win = foxytunesGetEmusicWindow();
        if (win) {
            win.dlm_web.goThere(url);
        } else {
            foxytunesLaunchExternalURL(url);
        }
    }
}

function foxytunesGoToURL(url, forceOpenInTab) {

  url = gFoxyTunesSanitizer.sanitizeURL(url);
  if (foxytunesIsInEmusic()) {
    foxytunesEmusicGoToUrl(url);
  } else if (!foxytunesIsInThunderbird()) {
	// Firefox
	if (foxytunesShouldOpenWindowsInTabs() || forceOpenInTab) {
        var win = foxytunesGetBrowserWindow();
        if (win) {
       		var newTab = win.getBrowser().addTab(url);
            win.getBrowser().selectedTab = newTab;
        } else {
            foxytunesOpenBrowserWindow(url);
        }
	} else {
       foxytunesOpenBrowserWindow(url);
	}
  } else {
	// Thunderbird
	foxytunesLaunchExternalURLFromThunderbird(url);
  }
}

function foxytunesOpenInTabs(urlList) {
    if (urlList.length == 0) return;

    if (urlList.length == 1) {
        foxytunesGoToURL(urlList[0]);
        return;
    }

    urlList = gFoxyTunesSanitizer.sanitizeURL(urlList.join("|")).split("|");

    // are we in Thunderbird?
    if (foxytunesIsInThunderbird()) {
       for (var i=0; i < urlList.length; i++) {
           foxytunesLaunchExternalURLFromThunderbird(urlList[i]);
       }
       return;
    }

    // open in new window
    if (!foxytunesShouldOpenWindowsInTabs()) {
        foxytunesOpenBrowserWindow(urlList.join("|"));
        return;
    } 

    // open in tabs
    var win = foxytunesGetBrowserWindow();
    if (!win) {
        // open new window
        foxytunesOpenBrowserWindow(urlList.join("|"));
        return;
    }

    // we have a window, add tabs
    var browser = win.getBrowser();
    if (browser) {
        var firstNewTab = null;        
        for (var i=0; i < urlList.length; i++) {
            var newTab = browser.addTab(urlList[i]);
            if (i == 0) {
                firstNewTab = newTab;
            }
        }
        browser.selectedTab = firstNewTab;
    }  
} 

function foxytunesShowAlertWithDelay(parent, title, text, timeout) {
    setTimeout (function() {foxytunesShowAlert(parent, title, text);}, timeout);
}

function foxytunesShowAlert(parent, title, text) {
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"];
	promptService = promptService.getService(Components.interfaces.nsIPromptService);
	promptService.alert(parent, title, text);
}

function foxytunesShowPrompt(parent, title, text, initialValue) {
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"];
	promptService = promptService.getService(Components.interfaces.nsIPromptService);

	if (!initialValue) {
		initialValue = "";
	}
	var answer = { value: initialValue };
    	var dummy = { value: false };
	var bOK = promptService.prompt(window, title, text, answer, null, dummy);

	if (bOK) {
		return answer.value;
	} else {
		return null;
	}
}


function foxytunesStringPadRight(str, length) {
	while (str.length < length) {
		str = str + " ";
	}
	return str;
}

function foxytunesGetLocaleString(strName, formattingValues) {
	var str = null;
	try {
		var strbundle = document.getElementById("foxytunes-strings");
		var strbundleFallback = document.getElementById("foxytunes-strings-fallback");
		if (formattingValues === undefined) {
            try {
    			str = strbundle.getString(strName);
            } catch(e) {
    			str = strbundleFallback.getString(strName);
            }
		} else {
            try {
    			str = strbundle.getFormattedString(strName, formattingValues);
            } catch(e) {
    			str = strbundleFallback.getFormattedString(strName, formattingValues);
            }
		}
	} catch (err) {
		dump("Couldn't get string: " + strName + "\n");
	}
	return str;
}

function foxytunesWriteSinglePreference(key, value) {
   var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
   var pref = prefService.getBranch("foxytunes."); 

   try {
     pref.setCharPref(key, value);
   } 
   catch (err) {
     dump("\nSetting preference for key " + key + " (" + value + ") failed: " + err + "\n");
   }
   try {
	prefService.savePrefFile(null);
   }
   catch (err) {
        dump("\nSaving preferences failed: " + err + "\n");
   }
}

function foxytunesWriteSingleUnicharPreference(key, value) {
   var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
   var pref = prefService.getBranch("foxytunes."); 

   try {
     var str = Components.classes["@mozilla.org/supports-string;1"]
                      .createInstance(Components.interfaces.nsISupportsString);
        str.data = value     
        pref.setComplexValue(key, Components.interfaces.nsISupportsString, str);
   } 
   catch (err) {
     dump("\nSetting preference for key " + key + " (" + value + ") failed: " + err + "\n");
   }
   try {
	prefService.savePrefFile(null);
   }
   catch (err) {
        dump("\nSaving preferences failed: " + err + "\n");
   }
}

function foxytunesReadSingleUnicharPreference(key, defaultVal) {
   var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
   var pref = prefService.getBranch("foxytunes."); 

   var val;
   try {
     val = pref.getComplexValue(key, Components.interfaces.nsISupportsString).data;
   } 
   catch (err) {
     val = defaultVal; 
   }
   return val;
}


function foxytunesReadSinglePreference(key, defaultVal) {
   var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
   var pref = prefService.getBranch("foxytunes."); 

   var val;
   try {
     val = pref.getCharPref(key);
   } 
   catch (err) {
     val = defaultVal; 
   }
   return val;
}

function foxytunesShortcutsEnabledByDefault() {
  // disabling shortcuts by default from everywhere
  // default one might cause issues when editing online forms
  return false;
/*
  if (foxytunesIsInThunderbird()) {
	return 'false';
  } else {
	return 'true';
  }
*/
}

function foxytinesTrimString(string) {
	// collapse multiple white space characters into a single one:
	string = string.replace(/\s+/g, " ");

	// remove the leading space
	if (string.charAt(0) == ' ') {
		string = string.substr(1);
	}
		
	// remove the trailing space
	if (string.charAt(string.length - 1) == ' ') {
		string = string.substr(0, string.length - 1);
	}

	return string;
} 

function foxytunesGetTextFromClipboard() {
    var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"].
                            getService(Components.interfaces.nsIClipboard);
    if (!clipboard) return '';

    var transferable = Components.classes["@mozilla.org/widget/transferable;1"].
                            createInstance(Components.interfaces.nsITransferable);
    if (!transferable) return '';


    transferable.addDataFlavor("text/unicode");
    try {
        clipboard.getData(transferable, clipboard.kGlobalClipboard);
    } catch (e) {return ' ';};

    var str = new Object();
    var strLength = new Object();
    try {
        transferable.getTransferData("text/unicode", str, strLength);
    } catch (e) {return ' ';};

    if (str) {
        str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
    } else {
        return '';
    }
       
    if (str) {
        var text = str.data.substring(0, strLength.value / 2);
        return text;
    }

    return '';
}

function foxytunesGetSelection() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var selection = focusedWindow.getSelection();
    if (selection) {
        selection = selection.toString();
        selection = selection.replace(/^\s+/, "");
        selection = selection.replace(/\s+$/, "");
        selection = selection.replace(/\s+/g, " ");
    } 

	return selection;
}

function foxytunesGetClippedText(text, length) {
    if (typeof length == 'undefined') {
        length = 15;
    }
    var clippedText; 
    if (text.length > length) {
        clippedText = text.substr(0,length) + "...";
    } else {
        clippedText = text;
    }
    return clippedText;
}

function foxytunesSanitizeURL(url, base) {
    if (!url) return null;

    var ioService = Components.classes["@mozilla.org/network/io-service;1"].
			              getService(Components.interfaces.nsIIOService);
    var uri = null;
    try {
        uri = ioService.newURI(url, null, base ? base : null);
    } catch(e) { return null; }

    if (uri.schemeIs("http") || uri.schemeIs("https") || uri.schemeIs("ftp")) {
        return uri.spec;
    }   

    return null;
}

function foxytunesClearMenupopup(elem) {
    if (!elem) return;
	var children = elem.childNodes;
    for (var i=children.length-1; i >=0 ; i--) {
    	elem.removeChild(children[i]);
	} 

    // the following hides the scroll arrows, in case they were shown
    // for a previous (high) menu and now are no longer needed
    var kids = document.getAnonymousNodes(elem);
    if (kids.length > 0) {
        var arrowscrollbox = kids[0];
        var kids = document.getAnonymousNodes(arrowscrollbox);
        for (var i=0; i < kids.length; i++) {   
            if (kids[i].localName == 'autorepeatbutton') {
                kids[i].collapsed = true;
            }
        }
    }
}

/* problem:
   1. collapse="true" persist="collapse"
   2. when panel is shown (collapse="false"), the persistance mechanism removes the  entry from localstore
      leaving us with the default collapse="true" - bug
   3. solution - have two attributes 'collapse' and 'not-collapse' and keep them always synched
   4. on startup - if both have the same value, fix the real attribute
*/

function PersistanceFixer(id, attrName) {
    this.id = id;
    this.attrName = attrName;
    this.notAttrName = 'not-' + attrName;
    this.elem = document.getElementById(id);

    var currentValue = this.elem.getAttribute(this.attrName);
    var currentNotValue = this.elem.getAttribute(this.notAttrName);
    if (currentValue == currentNotValue) {
        this.elem.setAttribute(this.attrName, this.stringNot(currentValue));
    }

    var me = this;
    this.elem.addEventListener("DOMAttrModified", function(event) { me.attrModified(event); }, false);
}

PersistanceFixer.prototype = {
    attrModified : function(event) {
        if (event.attrName != this.attrName) {
            return;
        }

        var newFixValue =  this.stringNot(event.newValue);
        this.elem.setAttribute(this.notAttrName, newFixValue);
        
    },

    stringNot : function(strBoolVal) {
        return strBoolVal == 'true' ? 'false' : 'true';
    }
}

function foxytunesWindowIsMinibrowser(win) {
    if (!win || !win.document) return false;
    return win.document.documentElement.getAttribute('windowtype') == 'foxytunes:minibrowser';
}

function foxytunesWindowIsMinimode(win) {
    if (!win || !win.document) return false;
    return win.document.documentElement.getAttribute('windowtype') == 'foxytunes:minimode';
}

function foxytunesIsInMinimode() {
    return foxytunesWindowIsMinimode(window) || 
            (window.opener && foxytunesWindowIsMinimode(window.opener));
}

function foxytunesGetPlayerShortNameFromContractID(contract) {
    var name = foxytunesTryGetFoxyTunesPlayerFromContractID(contract);
    if (name) {
        return name.toLowerCase();
    } 
    return null;
}


function foxytunesTryGetFoxyTunesPlayerFromContractID(contract) {
   try {
	var contractArray = contract.split("/");
	if (contractArray[1].toLowerCase() != 'foxytunes') {
		return null;
	}
	var subModule = contractArray[2];
	var subModuleArray = subModule.split(";");
	return subModuleArray[0];
   } catch (err) {
	dump("\nError while parsing contractID: " + contract + " - " + err + "\n");
	return null;
   }
}

function foxytunesIsNumber(x){
	return parseInt(x, 10) == x;
}

function foxytunesSeconds2TimeStr(length) {
    if (!foxytunesIsNumber(length)) {
		return null;
	}

  	if (length == 4294967) {
		length = 0; // winamp
	}

	if (length == 4294967295) {
		length = 0; // QCD
        }

	var length_hours = Math.floor(length / (60*60));
	length -= length_hours*60*60;
	var length_mins =  Math.floor(length / 60);
	if ((length_hours > 0) && (length_mins < 10)) {
		length_mins = '0' + length_mins;
	}
	var length_secs =  length - length_mins*60;
	if (length_secs < 10) {
		length_secs = '0' + length_secs;
	}
	var timeStr = length_mins + ':' + length_secs;
	if (length_hours > 0) {
		timeStr = length_hours + ':' + timeStr;
	}
	return timeStr;
}

var gFoxyTunesLastMenu = null;
function foxytunesCloseLastContextMenu(event) {
    var target      = event.originalTarget;
    var localName     = target.localName;

    if ((localName != 'menu') && (localName != 'menuitem')) {
        return;
    }


    if (gFoxyTunesLastMenu && 
        (gFoxyTunesLastMenu != target) &&
        (gFoxyTunesLastMenu.parentNode == target.parentNode)) {
        if (gFoxyTunesLastMenu.id.match(/foxy/)) {
            gFoxyTunesLastMenu.firstChild.hidePopup();
        }
    }


    if (localName == 'menu') {
        gFoxyTunesLastMenu = target;   
    }
}


function foxytunesInitMenupopups() {
    var menupopups = document.getElementsByTagName('menupopup');
    for (var i=0; i < menupopups.length; i++) {
        var menupopup = menupopups[i];
        menupopup.addEventListener('mouseover', foxytunesCloseLastContextMenu, false);
//        dump(menupopup.id + ' ---\n');
    }
}

function foxytunesReadRegistryValue(key, path, name) {
    const nsIWindowsRegKey = Components.interfaces.nsIWindowsRegKey;
    try {
        var root = nsIWindowsRegKey.ROOT_KEY_CURRENT_USER;
        key.open(root, path, nsIWindowsRegKey.ACCESS_READ);
    } catch(e) { 
        try {
            var root = nsIWindowsRegKey.ROOT_KEY_LOCAL_MACHINE;
            key.open(root, path, nsIWindowsRegKey.ACCESS_READ);
        } catch(e) { return null; }
    }

    var value = null;
    try {
        value = key.readStringValue(name);
        key.close();
    } catch(e) {}
    return value;
}

function foxytunesGetDefaultBrowserLocation() {
    try {
        const nsIWindowsRegKey = Components.interfaces.nsIWindowsRegKey;
        var key = Components.classes["@mozilla.org/windows-registry-key;1"]
                        .createInstance(nsIWindowsRegKey);

        var path = "SOFTWARE\\CLASSES\\.html";

        var handler = foxytunesReadRegistryValue(key, path, '');
        if (!handler) return null;

        path = "SOFTWARE\\CLASSES\\" + handler + "\\shell\\open\\command";
        var command = foxytunesReadRegistryValue(key, path, '');
        if (!command) return null;

        if (command.substr(0,1) == '"') {
            var commandArr = command.split('"');
            return commandArr[1];
        } else {
            var commandArr = command.split(' ');
            return commandArr[0];
        }
    } catch (e) {
        dump("Couldn't get default browser location: " + e + "\n");
        return null;
    }
}

function foxytunesGetDefaultBrowserIcon() {
    var commandPath = foxytunesGetDefaultBrowserLocation();
    if (!commandPath) return 'moz-icon:a.html?size=16';

    FTJSLib.include(FTJSLib.jslib_fileutils);
    var fileUtils = new FTJSLib.FileUtils;

    var url = fileUtils.pathToURL(commandPath);

    return "moz-icon://" + url + "?size=16";
}

function foxytunesGetPlatformFull() {
	return navigator.platform.toLowerCase();
}

function foxytunesGetPlatform() {
	var platform = navigator.platform.toLowerCase();
	
	if (platform.indexOf('linux') != -1) {
		return 'linux';
	}

	if (platform.indexOf('mac') != -1) {
		return 'mac';
	}

	return 'windows';
}

function foxytunesGetAppVersion() {
    var ver = null;
    try {
     var app = Components.classes["@mozilla.org/xre/app-info;1"]
                   .getService(Components.interfaces.nsIXULAppInfo)
                   .QueryInterface(Components.interfaces.nsIXULRuntime);
     ver = app.version;
    } catch(e) {}
    return ver;
}

function foxytunesGetAppName() {
    var name = "unknown";
    try {
        var app = Components.classes["@mozilla.org/xre/app-info;1"]
                   .getService(Components.interfaces.nsIXULAppInfo)
                   .QueryInterface(Components.interfaces.nsIXULRuntime);
        var id = app.ID;
        switch(id)
        {
            case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
                name = "firefox";
                break;
            case "{3550f703-e582-4d05-9a08-453d09bdfdc6}":
                name = "thunderbird";
                break;
            case "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
                name = "mozilla";
                break;
            case "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}":
                name = "seamonkey";
                break;
            case "{a463f10c-3994-11da-9945-000d60ca027b}":
                name = "flock";
                break;
            case "dlm@emusic.com":
                name="emusic";
                break;
        }
    } catch(e) {}

    return name;
}

function foxytunesDoAndHidePleaseWait(func) {
     try {
            func();
     } catch(e) {
            dump('Error while trying to run func and close PleaseWait: ' + e + '\n');
     }
     foxytunesShowPleaseWait(false);
}

function foxytunesFixLocalStore() {
    try {
        FTJSLib.include(FTJSLib.jslib_rdf);
        var RDF = new FTJSLib.RDF("rdf:local-store");
        var node = RDF.getNode(foxytunesGetMinibrowserURL() + "#main-window");
        if (node != null) {
            try {
                node.removeAttribute("screenX");
            } catch(e) {}
            try {
                node.removeAttribute("screenY");
            } catch(e) {}
            RDF.flush();
        }
    } catch(e) { dump("Problem fixing local store - " + e + "\n"); }
}

function foxytunesGetBaseWindow (win) {
  var baseWindow = null;
  try {
    baseWindow = win.QueryInterface(Components.interfaces.nsIInterfaceRequestor).
                 getInterface(Components.interfaces.nsIWebNavigation).
                 QueryInterface(Components.interfaces.nsIDocShellTreeItem).
                 treeOwner.QueryInterface(Components.interfaces.nsIInterfaceRequestor).
                 getInterface(Components.interfaces.nsIXULWindow).
                 docShell.QueryInterface(Components.interfaces.nsIDocShell).
                 QueryInterface(Components.interfaces.nsIBaseWindow);
  } catch (e) {};
  return baseWindow;
}

function foxytunesGetMostRecentWindow(windowType) {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow(windowType);
    return win;
}

function foxytunesShowBalloonHelp(x, y, title, text, timeout) {
  var features = "chrome, dialog=no, popup";
  features += ",top=" + y + "," + "left=" + x;
  window.openDialog("chrome://foxytunes/content/foxytunesBalloonHelp.xul", "_blank", features, title, text, timeout);
}

function foxytunesShowBalloonHelpWithTip(x, y, text, timeout, bLeftBallon) {
  var features = "chrome, dialog=no, popup";
  features += ",top=" + y + "," + "left=" + x;
  window.openDialog("chrome://foxytunes/content/foxytunesBalloonHelpWithTip.xul", "_blank", features, text, timeout, bLeftBallon);
}

try {
    Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
        getService(Components.interfaces.mozIJSSubScriptLoader).
        loadSubScript('chrome://foxytunes/content/ftlib/ftlib.js');
        FTJSLib.include(FTJSLib.jslib_prefs);
} catch(e) { dump('cannot load foxytunes lib ' + e + '\n'); }


function foxytunesPreferenceManager() {
        this._prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
        this._pref = this._prefService.getBranch("foxytunes."); 

        this.PREF_BOOL = Components.interfaces.nsIPrefBranch.PREF_BOOL;
        this.PREF_INT = Components.interfaces.nsIPrefBranch.PREF_INT;
        this.PREF_STRING = Components.interfaces.nsIPrefBranch.PREF_STRING
        this.typeToPrefType = new Object();
        this.typeToPrefType['boolean'] = this.PREF_BOOL;
        this.typeToPrefType['number'] = this.PREF_INT;
        this.typeToPrefType['string'] = this.PREF_STRING;
}

foxytunesPreferenceManager.prototype = {

    setBoolPref : function(key , value)  {
        value = value ? true : false;
        try {
            this._pref.setBoolPref(key, value);
        }
        catch (err) {
            dump("\nSetting preference for key " + key + " (" + value + ") failed: " + err + "\n");
        }
        try {
	        this._prefService.savePrefFile(null);
        }
        catch (err) {
            dump("\nSaving preferences failed: " + err + "\n");
        }
    },

    getBoolPref : function(key, defaultVal)  {        
        var val = defaultVal; 
        try {
            val = this._pref.getBoolPref(key);
        } 
        catch (err) {
            dump("\nGetting preference for key " + key + " failed: " + err + "\n");
        }
        return val;
    },

    getPrefFunc: function(type) {
        switch (type) {
            case this.PREF_BOOL:
                return this._pref.getBoolPref;
                break;
            case this.PREF_INT:
                return this._pref.getIntPref;
                break;
            case this.PREF_STRING:
                return this._pref.getCharPref;
                break;
        }
    },

    setPref: function(key, value) {
        var setterFunc = null;
        var setterFunc = this.getPrefFunc(this.typeToPrefType[typeof value]);
        if (setterFunc) {
            setterFunc(key, value);
        }
    },

    getPref: function(key, defaultValue) {
        var val = defaultValue;
        var type = this._pref.getPrefType(key);
        var getterFunc = this.getPrefFunc(type);
        if (getterFunc) {
            try {
                val = getterFunc(key);
            } catch(err) {
                dump("\nGetting preference for key " + key + " failed: " + err + "\n");
            }
        }
        return val;
    }

}

var gFoxytunesPreferenceManager = new foxytunesPreferenceManager();

function foxytunesUIElementToPref(event) {
    var menuItem = event.target;
    var value = menuItem.getAttribute("checked") == 'true';
    var key = menuItem.getAttribute("ftPref");
    gFoxytunesPreferenceManager.setBoolPref(key , value);
}


function foxytunesPrefToUIElements(event) {
    var menuPopup = event.target;
    var menuItemsList  = menuPopup.getElementsByTagName("menuitem");

    for (var i = 0;  i<menuItemsList.length; i++ )  {
        var menuItem = menuItemsList.item(i)
        var key = menuItem.getAttribute("ftPref");
        var value = gFoxytunesPreferenceManager.getBoolPref(key, true);
        menuItem.setAttribute("checked", value);
    }
}

function foxytunesEscapeNonAsciiText (str) {
    if (!str) {
        return null;
    }
    var res = '';
    for (var i=0; i<str.length; i++) {
        if (str.charCodeAt(i) > 127) {
            res += escape(str[i]);
        } else {
            res += str[i];
        }
   }
   return res;
}

function foxytunesGetExtensionPath () {
 var id = "{463F6CA5-EE3C-4be1-B7E6-7FEE11953374}";
 return Components.classes["@mozilla.org/extensions/manager;1"]
                  .getService(Components.interfaces.nsIExtensionManager)
                  .getInstallLocation(id)
                  .getItemLocation(id); 

}

function foxytunesGetIconPath () {
 var foxyTunesIconPath = foxytunesGetExtensionPath();

 foxyTunesIconPath.append('chrome');
 foxyTunesIconPath.append('icons');
 foxyTunesIconPath.append('default');
 foxyTunesIconPath.append('foxytunes-minimode.ico');

 var charset = null;
 if (gFoxytunesUtils) {
    charset = gFoxytunesUtils.GetCurrentCharset();
 } else {
    charset = "UTF-8";
 }

 gFoxyTunesUnicodeConverter.charset = charset;
 var path = gFoxyTunesUnicodeConverter.ConvertFromUnicode(foxyTunesIconPath.path);
 return path;
}

function foxytunesMd5(str) {
    var converter =
    Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
        createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

    converter.charset = "UTF-8";
    var result = {};
    var data = converter.convertToByteArray(str, result);
    var ch = Components.classes["@mozilla.org/security/hash;1"]
        .createInstance(Components.interfaces.nsICryptoHash);
    ch.init(ch.MD5);
    ch.update(data, data.length);
    var hash = ch.finish(false);

    function toHexString(charCode) {
        return ("0" + charCode.toString(16)).slice(-2);
    }

    var arr = [];
    for (i in hash) {
	arr.push(toHexString(hash.charCodeAt(i)));
    }
    var s = arr.join("");
    return s;
}

function foxytunesGetDefaultPlayerForOs() {
    var playerClass = null;
    var platform = foxytunesGetPlatform();
    switch (platform) {
        case 'windows': playerClass = '@foxytunes.org/FoxyTunes/WindowsMediaPlayer;1';
                        break;
        case 'mac': playerClass = '@foxytunes.org/FoxyTunes/iTunes;1';
                    break;
        case 'linux': playerClass = '@foxytunes.org/FoxyTunes/XMMS;1';
                      break;
    }
    return playerClass;    
}

function foxytunesGetLocaleStringExternalfunction(strName, formattingValues) {
    try {
        var stringBundleService = Components.classes['@mozilla.org/intl/stringbundle;1'].
                                    createInstance(Components.interfaces.nsIStringBundleService);
        var strbundle = stringBundleService.createBundle('chrome://foxytunes/locale/foxytunes.properties');
        var strbundleFallback = stringBundleService.createBundle('chrome://foxytunes/content/locale/en-US/foxytunes.properties');
        var val = '';

        if (formattingValues === undefined) {
            try {
    		    val = strbundle.GetStringFromName(strName);
            } catch(e) {
    	        val = strbundleFallback.GetStringFromName(strName);
            }
        } else {
            try {
    		    val = strbundle.formatStringFromName(strName, formattingValues, formattingValues.length);
            } catch(e) {
    			val = strbundleFallback.formatStringFromName(strName, formattingValues, formattingValues.length);
            }
        }
    } catch (err) {
        dump("Couldn't get string: " + strName + "\n");
    }

    return val;
}

function foxytunesOpenSignatuensConfigurationWindow() {
    window.openDialog('chrome://foxytunes/content/signatures/signaturesConfiguration.xul', '',
						  'chrome,centerscreen, modal');
}

function foxytunesGetExtensionVersion(guid) {
    var value = null;
    try {
        var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
        var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
                            .getService(Components.interfaces.nsIExtensionManager).datasource;
        var root = RDFService.GetResource("urn:mozilla:item:" + guid);
        var itemArc = RDFService.GetResource("http://www.mozilla.org/2004/em-rdf#version");
        var target = extensionDS.GetTarget(root, itemArc, true);
        value = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    } catch(e) {}
    return value;
}
